import type { AxiosRequestConfig, AxiosResponse } from 'axios'

export type HttpHeaderType = Record<string, any>

export interface BaseApi<D = any> extends AxiosRequestConfig<D>{
  // 请求前的钩子函数
  beforeRequest?: (params: any) => any
  // 请求前的参数处理
  beforeRequestConfig?: (config: AxiosRequestConfig) => AxiosRequestConfig
  // 请求前置的query中的参数
  beforeRequestQuery?: (query: any) => any
  // 请求失败的钩子
  onError?: (e: any) => void
  // 请求接口格式化处理
  urlParser?: (url: string) => string
  // 请求数据格式化 同步方法，不支持Promise
  responseTransform?: <R, D>(response: AxiosResponse<D>) => R
  // 请求前的数据格式化 同步方法，不支持Promise
  requestTransform?: <D>(config: BaseApi<D>) => BaseApi<D>
  // 请求类型
  dataType?: 'form'|'upload'|'json'
  // 请求后的钩子函数
  afterRequest?: (response: AxiosResponse) => AxiosResponse | undefined
}

export interface CramiHttpOptions{
  headers?: (() => HttpHeaderType)|HttpHeaderType
  // 请求前的钩子函数
  beforeRequest?: (params: any) => any
  // 请求前的参数处理
  beforeRequestConfig?: (config: AxiosRequestConfig) => AxiosRequestConfig
  // 请求前置的query中的参数
  beforeRequestQuery?: (query: any) => any
  // 请求失败的钩子
  onError?: (e: any) => void
  // 请求接口格式化处理
  urlParser?: (url: string) => string
  // 请求数据格式化 同步方法，不支持Promise
  responseTransform?: <R = any, D = any>(response: AxiosResponse<D>) => R
  // 请求前的数据格式化 同步方法，不支持Promise
  requestTransform?: <D>(config: BaseApi<D>) => BaseApi<D>
}
